org.apache.ode.bpel.pmapi

## Interface BpelManagementFacade

- All Superinterfaces:
    InstanceManagement, ProcessManagement
  All Known Implementing Classes:
    BpelManagementFacadeImpl

      public interface BpelManagementFacade
      extends ProcessManagement, InstanceManagement

  Instance management interaction interface. Instance management is a broad concept that covers instance introspection, debugging, and monitoring. This interface allows external systems to perform these functions.

  NOTE: this interface is not currently intended to be published. It is currently used by the higher-level debugging facility.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ActivityBreakpoint` | `addActivityBreakpoint(java.lang.Long iid, java.lang.String activity)` Adds an activity breakpoint.
    `ActivityBreakpoint` | `addGlobalActivityBreakpoint(java.lang.String procId, java.lang.String activity)` Adds an global activity breakpoint.
    `VariableModificationBreakpoint` | `addVariableModificationBreakpoint(java.lang.Long iid, java.lang.String scopeName, java.lang.String variable)` Adds a variable modification breakpoint.
    `Breakpoint[]` | `getBreakpoints(java.lang.Long iid)` Returns the breakpoints registered with the process instance.
    `javax.xml.namespace.QName` | `getCompletedFault(java.lang.Long iid)` Gets the fault associated with a completed process instance.
    `CorrelationKey` | `getCorrelation(java.lang.Long iid, java.lang.Long scopeId, java.lang.String correlationSet)` Gets a correlation.
    `int` | `getEventCount(java.lang.Long iid)` Get the current number of events for an instance.
    `EventInfoListDocument` | `getEvents(java.lang.Long iid, int startIdx, int count)` Get exeuction event history for a process instance.
    `Breakpoint[]` | `getGlobalBreakpoints(java.lang.String procId)` Returns the global breakpoints registered with the process instance.
    `OProcess` | `getProcessDef(java.lang.String procId)` Return the process model.
    `java.lang.Long` | `getProcessInstance(java.lang.String pid, CorrelationKey ckey)` Get the process instance with the given correlation correlationKey.
    `java.lang.Long[]` | `getScopeInstancesForScope(java.lang.Long iid, java.lang.String scopeName)` Returns all the scope instance ids for a given instance and scope name.
    `java.util.Date` | `getStartTime(java.lang.Long iid)` Get the time that a process instance was started (created).
    `short` | `getState(java.lang.Long iid)` Get the state of a process instance.
    `java.lang.String` | `getVariable(java.lang.Long iid, java.lang.Long scopeId, java.lang.String varName)` Gets variable data.
    `void` | `removeBreakpoint(java.lang.Long iid, Breakpoint sp)` Removes a breakpoint
    `void` | `removeGlobalBreakpoint(java.lang.String procId, Breakpoint sp)` Removes a global breakpoint
    `void` | `setCorrelation(java.lang.Long iid, java.lang.Long scopeId, java.lang.String correlationSet, javax.xml.namespace.QName[] propertyNames, CorrelationKey values)` Sets a correlation.
    `void` | `setVariable(java.lang.Long iid, java.lang.Long scopeId, java.lang.String varName, java.lang.String data)` Sets a variable
    `void` | `step(java.lang.Long iid)` Single step through a process instance.

    - ### Methods inherited from interface org.apache.ode.bpel.pmapi.ProcessManagement

      `activate, getExtensibilityElements, getProcessInfo, getProcessInfoCustom, listAllProcesses, listProcesses, listProcessesCustom, listProcessesSummaryOnly, setPackageRetired, setProcessProperty, setProcessPropertyNode, setRetired`

    - ### Methods inherited from interface org.apache.ode.bpel.pmapi.InstanceManagement

      `delete, fault, getEventTimeline, getInstanceInfo, getScopeInfo, getScopeInfoWithActivity, getVariableInfo, listAllInstances, listAllInstancesWithLimit, listEvents, listInstances, listInstancesSummary, queryInstances, recoverActivity, resume, suspend, terminate`

- - ### Method Detail

    - #### getStartTime

          java.util.Date getStartTime(java.lang.Long iid)
                                      throws ManagementException

      Get the time that a process instance was started (created).
      Parameters:
        `iid` - process instance identifier
      Returns:
        time the instance was started
      Throws:
        `ManagementException`

    - #### getState

          short getState(java.lang.Long iid)
                         throws ManagementException

      Get the state of a process instance.
      Parameters:
        `iid` - process instance identifier
      Returns:
        state of the instance
      Throws:
        `ManagementException`

    - #### getProcessInstance

          java.lang.Long getProcessInstance(java.lang.String pid,
                                          CorrelationKey ckey)
                                            throws ManagementException

      Get the process instance with the given correlation correlationKey.
      Parameters:
        `pid` - the process identifier
        `ckey` - the correlation correlationKey to match
      Returns:
        process instance identifier of instance matching the given correlationKey
      Throws:
        `ManagementException`

    - #### getEvents

          EventInfoListDocument getEvents(java.lang.Long iid,
                                        int startIdx,
                                        int count)
                                          throws ManagementException

      Get exeuction event history for a process instance.
      Parameters:
        `iid` - process instance identifier
        `startIdx` - first evet
        `count` - maximum number of events to get
      Returns:
        array of `ProcessInstanceEvent`s.
      Throws:
        `ManagementException`

    - #### getEventCount

          int getEventCount(java.lang.Long iid)
                            throws ManagementException

      Get the current number of events for an instance.
      Parameters:
        `iid` - process instance identifier
      Returns:
        number of events in event history
      Throws:
        `ManagementException`

    - #### getScopeInstancesForScope

          java.lang.Long[] getScopeInstancesForScope(java.lang.Long iid,
                                                   java.lang.String scopeName)
                                                     throws ManagementException

      Returns all the scope instance ids for a given instance and scope name. Multiple scopes instances are only possible due to a BPEL 'while' activity.
      Throws:
        `ManagementException`

    - #### getVariable

          java.lang.String getVariable(java.lang.Long iid,
                                     java.lang.Long scopeId,
                                     java.lang.String varName)
                                       throws ManagementException

      Gets variable data.
      Parameters:
        `iid` -
        `scopeId` -
        `varName` -
      Returns:
      Throws:
        `ManagementException`

    - #### setVariable

          void setVariable(java.lang.Long iid,
                         java.lang.Long scopeId,
                         java.lang.String varName,
                         java.lang.String data)

      Sets a variable
      Parameters:
        `iid` -
        `scopeId` -
        `varName` -
        `data` -

    - #### setCorrelation

          void setCorrelation(java.lang.Long iid,
                            java.lang.Long scopeId,
                            java.lang.String correlationSet,
                            javax.xml.namespace.QName[] propertyNames,
                            CorrelationKey values)
                              throws ManagementException

      Sets a correlation.
      Parameters:
        `iid` -
        `scopeId` -
        `correlationSet` - name of the correlation set
        `propertyNames` - properties to set on correlation set
        `values` - property values as a CorrelationKey object
      Throws:
        `ManagementException`

    - #### getCorrelation

          CorrelationKey getCorrelation(java.lang.Long iid,
                                      java.lang.Long scopeId,
                                      java.lang.String correlationSet)
                                        throws ManagementException

      Gets a correlation.
      Parameters:
        `iid` -
        `scopeId` -
        `correlationSet` -
      Returns:
      Throws:
        `ManagementException`

    - #### getProcessDef

          OProcess getProcessDef(java.lang.String procId)
                                 throws ManagementException

      Return the process model.
      Parameters:
        `procId` -
      Returns:
      Throws:
        `ManagementException`

    - #### step

          void step(java.lang.Long iid)
                    throws ManagementException

      Single step through a process instance.
      Parameters:
        `iid` -
      Throws:
        `ManagementException`

    - #### getCompletedFault

          javax.xml.namespace.QName getCompletedFault(java.lang.Long iid)
                                                      throws ManagementException

      Gets the fault associated with a completed process instance.
      Parameters:
        `iid` -
      Returns:
      Throws:
        `ManagementException`

    - #### getBreakpoints

          Breakpoint[] getBreakpoints(java.lang.Long iid)
                                      throws ManagementException

      Returns the breakpoints registered with the process instance.
      Parameters:
        `iid` - process instance identifier
      Returns:
        array of `Breakpoint`s.
      Throws:
        `ManagementException`

    - #### getGlobalBreakpoints

          Breakpoint[] getGlobalBreakpoints(java.lang.String procId)
                                            throws ManagementException

      Returns the global breakpoints registered with the process instance.
      Parameters:
        `procId` -
      Returns:
        array of `Breakpoint`s.
      Throws:
        `ManagementException`

    - #### removeBreakpoint

          void removeBreakpoint(java.lang.Long iid,
                              Breakpoint sp)
                                throws ManagementException

      Removes a breakpoint
      Parameters:
        `iid` - a iid of null removes a global breakpoint.
        `sp` -
      Throws:
        `ManagementException`

    - #### removeGlobalBreakpoint

          void removeGlobalBreakpoint(java.lang.String procId,
                                    Breakpoint sp)
                                      throws ManagementException

      Removes a global breakpoint
      Parameters:
        `procId` -
        `sp` -
      Throws:
        `ManagementException`

    - #### addActivityBreakpoint

          ActivityBreakpoint addActivityBreakpoint(java.lang.Long iid,
                                                 java.lang.String activity)
                                                   throws ManagementException

      Adds an activity breakpoint.
      Parameters:
        `iid` - a iid of null adds a global activity breakpoint.
        `activity` -
      Returns:
      Throws:
        `ManagementException`

    - #### addGlobalActivityBreakpoint

          ActivityBreakpoint addGlobalActivityBreakpoint(java.lang.String procId,
                                                       java.lang.String activity)
                                                         throws ManagementException

      Adds an global activity breakpoint.
      Parameters:
        `procId` -
        `activity` -
      Returns:
      Throws:
        `ManagementException`

    - #### addVariableModificationBreakpoint

          VariableModificationBreakpoint addVariableModificationBreakpoint(java.lang.Long iid,
                                                                         java.lang.String scopeName,
                                                                         java.lang.String variable)

      Adds a variable modification breakpoint.
      Parameters:
        `iid` -
        `scopeName` -
        `variable` -
      Returns: